"use strict";

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance"); }

function _iterableToArrayLimit(arr, i) { if (!(Symbol.iterator in Object(arr) || Object.prototype.toString.call(arr) === "[object Arguments]")) { return; } var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

/**
 *
 * @param {Object} props - Properties passed to component
 * @returns {ReactElement}
 */
var Disclose = function Disclose(_ref) {
  var children = _ref.children,
      childrenStyle = _ref.childrenStyle,
      className = _ref.className,
      headerStyle = _ref.headerStyle,
      isDisabled = _ref.isDisabled,
      isInitiallyOpen = _ref.isInitiallyOpen,
      isOpen = _ref.isOpen,
      indented = _ref.indented,
      openHandler = _ref.openHandler,
      title = _ref.title,
      props = _objectWithoutProperties(_ref, ["children", "childrenStyle", "className", "headerStyle", "isDisabled", "isInitiallyOpen", "isOpen", "indented", "openHandler", "title"]);

  var _useState = (0, _react.useState)(isInitiallyOpen),
      _useState2 = _slicedToArray(_useState, 2),
      isExpanded = _useState2[0],
      setIsExpanded = _useState2[1];

  (0, _react.useEffect)(function () {
    if (isOpen !== undefined) setIsExpanded(isOpen);
  }, [isOpen]);
  (0, _react.useEffect)(function () {
    if (openHandler) {
      openHandler(setIsExpanded);
    }
  }, [openHandler]);

  var toggleOpenDisclose = function toggleOpenDisclose() {
    return !isDisabled && setIsExpanded(!isExpanded);
  };

  var contentClass = (0, _classnames["default"])("oui-disclose__content", {
    "border--sides border--bottom": childrenStyle === "border",
    "border--bottom": childrenStyle === "divider" && isExpanded
  });
  var linkClass = (0, _classnames["default"])("oui-disclose__link soft-half flush", {
    "background--faint display--block": headerStyle === "header",
    "border--all background--faint display--block": headerStyle === "header-bordered",
    "hard--left": !indented,
    "link--dark": !isDisabled,
    "link--disabled": isDisabled
  }, className);
  var arrowClass = (0, _classnames["default"])("oui-disclose", {
    "is-active": isExpanded
  });
  return _react["default"].createElement("div", {
    className: arrowClass,
    style: {
      marginTop: "-1px"
    }
  }, _react["default"].createElement("a", _extends({
    onClick: toggleOpenDisclose,
    className: linkClass
  }, props), _react["default"].createElement("div", {
    className: "flex flex-align--start oui-disclose__arrow"
  }, _react["default"].createElement("span", {
    className: "oui-disclose__symbol push--right"
  }), title)), _react["default"].createElement("div", {
    className: contentClass
  }, isExpanded && children));
};

Disclose.propTypes = {
  children: _propTypes["default"].node.isRequired,
  childrenStyle: _propTypes["default"].string,
  headerStyle: _propTypes["default"].string,
  indented: _propTypes["default"].bool,
  isDisabled: _propTypes["default"].bool,
  isInitiallyOpen: _propTypes["default"].bool,
  isOpen: _propTypes["default"].bool,
  noBorder: _propTypes["default"].bool,
  openHandler: _propTypes["default"].func,
  title: _propTypes["default"].oneOfType([_propTypes["default"].node, _propTypes["default"].string]).isRequired
};
Disclose.defaultProps = {
  indented: true
};
var _default = Disclose;
exports["default"] = _default;