function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance"); }

function _iterableToArrayLimit(arr, i) { if (!(Symbol.iterator in Object(arr) || Object.prototype.toString.call(arr) === "[object Arguments]")) { return; } var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

import React, { useState, useEffect } from "react";
import PropTypes from "prop-types";
import classNames from "classnames";
/**
 *
 * @param {Object} props - Properties passed to component
 * @returns {ReactElement}
 */

var Disclose = function Disclose(_ref) {
  var children = _ref.children,
      childrenStyle = _ref.childrenStyle,
      className = _ref.className,
      headerStyle = _ref.headerStyle,
      isDisabled = _ref.isDisabled,
      isInitiallyOpen = _ref.isInitiallyOpen,
      isOpen = _ref.isOpen,
      indented = _ref.indented,
      openHandler = _ref.openHandler,
      title = _ref.title,
      props = _objectWithoutProperties(_ref, ["children", "childrenStyle", "className", "headerStyle", "isDisabled", "isInitiallyOpen", "isOpen", "indented", "openHandler", "title"]);

  var _useState = useState(isInitiallyOpen),
      _useState2 = _slicedToArray(_useState, 2),
      isExpanded = _useState2[0],
      setIsExpanded = _useState2[1];

  useEffect(function () {
    if (isOpen !== undefined) setIsExpanded(isOpen);
  }, [isOpen]);
  useEffect(function () {
    if (openHandler) {
      openHandler(setIsExpanded);
    }
  }, [openHandler]);

  var toggleOpenDisclose = function toggleOpenDisclose() {
    return !isDisabled && setIsExpanded(!isExpanded);
  };

  var contentClass = classNames("oui-disclose__content", {
    "border--sides border--bottom": childrenStyle === "border",
    "border--bottom": childrenStyle === "divider" && isExpanded
  });
  var linkClass = classNames("oui-disclose__link soft-half flush", {
    "background--faint display--block": headerStyle === "header",
    "border--all background--faint display--block": headerStyle === "header-bordered",
    "hard--left": !indented,
    "link--dark": !isDisabled,
    "link--disabled": isDisabled
  }, className);
  var arrowClass = classNames("oui-disclose", {
    "is-active": isExpanded
  });
  return React.createElement("div", {
    className: arrowClass,
    style: {
      marginTop: "-1px"
    }
  }, React.createElement("a", _extends({
    onClick: toggleOpenDisclose,
    className: linkClass
  }, props), React.createElement("div", {
    className: "flex flex-align--start oui-disclose__arrow"
  }, React.createElement("span", {
    className: "oui-disclose__symbol push--right"
  }), title)), React.createElement("div", {
    className: contentClass
  }, isExpanded && children));
};

Disclose.propTypes = {
  children: PropTypes.node.isRequired,
  childrenStyle: PropTypes.string,
  headerStyle: PropTypes.string,
  indented: PropTypes.bool,
  isDisabled: PropTypes.bool,
  isInitiallyOpen: PropTypes.bool,
  isOpen: PropTypes.bool,
  noBorder: PropTypes.bool,
  openHandler: PropTypes.func,
  title: PropTypes.oneOfType([PropTypes.node, PropTypes.string]).isRequired
};
Disclose.defaultProps = {
  indented: true
};
export default Disclose;